package com.winhc.bigdata.spark.implicits

import com.winhc.bigdata.spark.const.BaseConst
import com.winhc.bigdata.spark.utils.PhoenixUtil
import org.apache.spark.sql.DataFrame

/**
 * @Author: XuJiakai
 * @Date: 2020/6/4 08:40
 * @Description:
 */
object PhoenixHelper {

  implicit class DataFrameEnhancer(df: DataFrame) {
    /**
     * 只有 catalog为in-memory方式可用
     *
     * @param tableName
     */
    def save2Phoenix(tableName: String): Unit = {
      val tmpTable = "tmp_" + tableName
      df.sparkSession.sql(PhoenixUtil.getPhoenixTempView(tmpTable, tableName))
      df.write
        .mode("append")
        .insertInto(tmpTable)
    }

    /**
     * catalog不限
     *
     * @param tableName
     */
    def save2PhoenixByJDBC(tableName: String): Unit = {
      df.write
        .mode("append")
        .jdbc(PhoenixUtil.getPhoenixJDBCUrl, tableName, PhoenixUtil.getPhoenixProperties)
      //        .jdbc(PhoenixUtil.getPhoenixJDBCUrl, tableName + BaseConst.PHOENIX_TABLE_NAME_FLAG, PhoenixUtil.getPhoenixProperties)
    }
  }

}
