package cn.oyohotels.utils

import com.winhc.bigdata.spark.utils.HBaseUtils
import org.apache.hadoop.hbase._
import org.apache.hadoop.hbase.client._
import org.apache.hadoop.hbase.util.Bytes
import org.slf4j.LoggerFactory


object HbaseUtil {
  final val FAMILY_NAME = "F"
  final val RT_NS = "default"
  private val logger = LoggerFactory.getLogger(this.getClass)

  val lrs = HbaseUtil.getClass.getResource("/").getPath

  lazy val conf = {
    val myConf = HBaseUtils.getHbaseConf()
    myConf
  }

  lazy val conn = {
    //本地开启
    ConnectionFactory.createConnection(conf)
  }

  def getTable(tbName: String, ns: String = RT_NS) = {
    conn.getTable(TableName.valueOf(ns, tbName))
  }

  def getRowData(tb: Table, rowkey: String, family: String = FAMILY_NAME) = {
    var m = Map.empty[String, String]
    try {

      val g = new Get(Bytes.toBytes(rowkey))
      // val g = new Get(rowkey.getBytes)
      val r = tb.get(g).rawCells()
      m = r.map(c1 => (Bytes.toString(CellUtil.cloneQualifier(c1)), Bytes.toString(CellUtil.cloneValue(c1)))).toMap
    } catch {
      case e: Throwable => e.printStackTrace()
    }
    m
  }

  def main(args: Array[String]): Unit = {
    val row = getRowData(getTable("COMPANY_SCORE_V3"), "100008680_101")
    println(row)
  }
}
