package com.winhc.bigdata.spark.utils

import java.util.Date

import org.apache.spark.sql.SparkSession

/**
 * @Description: MaxComputer2Phoenix
 * @author π
 * @date 2020/6/2815:44
 */
case class MaxComputer2Phoenix(spark: SparkSession,
                               phoenixCols: Seq[String], //phoenix 列
                               adsTable: String, //odps表
                               htable: String, //hbase表
                               ds: String, //分区
                               rowkey: Seq[String] //rowkey字段
                              ) extends LoggingUtils {
  //同步max到phoenix
  def syn() = {

    println(s"${htable} phoenix syn start! " + new Date().toString)

    val resTable = s"TEST_${htable}"

    println("------------" + resTable + "---------")

    val key = s"CONCAT_WS('_',${rowkey.mkString(",")}) AS rowkey"
    val res = phoenixCols.map(s => {
      if ("NEW_CID".equals(s.toUpperCase())) {
        s"cast ($s as string) as CID"
      } else {
        s"cast ($s as string) as ${s.toUpperCase}"
      }
    }) ++ Seq(key)

    val df = sql(
      s"""
         |select
         |${res.mkString(", ")}
         |from
         |${adsTable}
         |where ds = $ds
         |""".stripMargin)

    import com.winhc.bigdata.spark.implicits.PhoenixHelper._
    df.save2PhoenixByJDBC(s"${resTable.toUpperCase}")

    println(s"${htable} phoenix syn end! " + new Date().toString)
  }

}
